#ifndef PROFILER_H
#define PROFILER_H
#include <memory>
#include <list>
#include "profiler_lowlevel.h"

class Profiler
  {
public:
    struct ZoneInfo
      {
        const char *mName;
        double mWholeTime;
        double mSelfTime;
        int mNumExecutions;
      };

    virtual ~Profiler() { }
    virtual void Start()=0;
    virtual void Done()=0;

    typedef std::list<ZoneInfo>  ReportType;
    typedef ReportType::iterator ReportIter;
    ReportType mReport;

    static std::auto_ptr<Profiler> Create();
  };

#endif