/* func2d.h */
#ifndef __FUNCTION_2D_H
#define __FUNCTION_2D_H

#include "template.h"

class FunctionLinear2D
  {
public:
    virtual ScalarType Value(ScalarType x, ScalarType y) = 0;
    virtual ~FunctionLinear2D() { }
  };

class FunctionCubic2D : public FunctionLinear2D
  {
public:
    virtual void ValueAndGrad(ScalarType x, ScalarType y, ScalarType &value,
                              ScalarType &gradx, ScalarType &grady) = 0;
  };

class FunctionCubicAccurate2D : public FunctionCubic2D
  {
public:
    virtual void Grad(ScalarType x, ScalarType y, 
                      ScalarType &dx, ScalarType &dy) = 0;

    ScalarType PartialDeriv(ScalarType x, ScalarType y, 
                            ScalarType dx, ScalarType dy)
      {
        ScalarType gradx, grady;
        Grad(x,y,gradx,grady);
        return gradx*dx+grady*dy; 
      }
  };

#endif
