#ifndef __MERGE_SPLINES_2D_H
#define __MERGE_SPLINES_2D_H

#include "template.h"
#include "root2d.h"
#include <list>

namespace Merge2D
  {
    struct CornerNbhd
      {
        int mSide; // will be set by AddPiece
        DomainType2d mLocation;
      };


    void MergeContours(std::list<Root2D::Contour > &dest, 
              std::list<Root2D::Contour > &source, 
              ScalarType epsilon, int numtomerge, int *tomerge,
              int numcorners, CornerNbhd *corners);

    void MergeContours(std::list<Root2D::Contour > &dest, 
              ScalarType epsilon, int numtomerge, int *tomerge);

    void ConnectContours(std::list<Root2D::Contour > &dest, 
              std::list<Root2D::Contour > &source, 
              ScalarType epsilon, int numtomerge, int *tomerge);
  }

#endif