#ifndef MY_FUNCTION_DEFINITION_H
#define MY_FUNCTION_DEFINITION_H
#include "func2d.h"
#include "densemat.h"

class MyFunction2D : public FunctionCubic2D
  {
protected:
    // whatever data needs to be precomputed
    ScalarType mMinX, mMaxX, mMinY, mMaxY;
    Matrix::DenseMatrix<ScalarType> mPrecomputedData;

    // any helper functions used by the functions below
    void Helper(ScalarType x, ScalarType y, int &c0, int &r0, 
                ScalarType &xr, ScalarType &yr);

public:
    // whatever the parameters for precomputation are
    void Initialize(ScalarType minx, ScalarType maxx, 
                    ScalarType miny, ScalarType maxy);

    // for linear interpolation case
    ScalarType Value(ScalarType x, ScalarType y);

    // for cubic interpolation case, compute
    // value, gradx, grady from x,y and precomputed data
    void ValueAndGrad(ScalarType x, ScalarType y,
                      ScalarType &value, 
                      ScalarType &gradx, ScalarType &grady);
  };

#endif