#include "makeps.h"
#include <jiostr.h>

void main(void)
  {
    PS::Drawing drawing;
    PS::State state(drawing.GetState());
    PS::Path path;

    path.MoveTo(100, 100);
    path.LineTo(200, 200);
    path.LineTo(300, 100);
    path.Close();
    drawing.StrokePath(path, state);
    path.Clear();

    path.MoveTo(100, 120);
    path.LineTo(200, 220);
    path.LineTo(300, 120);
    PS::State state2(state);
    state2.SetRGB(1,0,.5);
    state2.SetLineThickness(5.0);
    state2.SetLineCap(PS::State::round_cap);
    state2.SetLineJoin(PS::State::bevel_join);
    drawing.StrokePath(path, state2);
    path.Clear();

    path.MoveTo(50, 150);
    path.LineTo(225, 150);
    path.LineTo(175, 50);
    path.Close();
    state.SetGray(0.5);
    drawing.FillPath(path, state);
    path.Clear();
    string epsfile;
    drawing.WriteEPS(epsfile, "Josh Levenberg", "EPS generation test");
    cout << epsfile;
  }