#ifndef __QUADRATIC_FUNCTION_H
#define __QUADRATIC_FUNCTION_H

#include "func1dmd.h"
#include "matrix.h"

class QuadraticFunction : public FunctionCubic1DMaxD
  {
protected:
    ScalarType mA, mB, mC;

public:
    void Init(ScalarType a, ScalarType b, ScalarType c)
      {
        mA=a;
        mB=b;
        mC=c;
#if 1
        mBoundType=0;
        mBound=Matrix::Abs(2*mA);
#else
        // although f''''(x) is 0 everywhere for a quadratic, I'm going to assume
        // that it is 1 for purposes of the stopping criteria.
        mBoundType=1;
        mBound=1;
#endif
      }


    ScalarType EvaluateValue(ScalarType x)
      {
        return (mA*x+mB)*x+mC;
      }
    ScalarType EvaluateDerivative(ScalarType x)
      {
        return 2*mA*x+mB;
      }
    ScalarType MaxDerivative(ScalarType center, ScalarType radius)
      {
        ScalarType derivleft  = Matrix::Abs(2*mA*(center-radius)+mB);
        ScalarType derivright = Matrix::Abs(2*mA*(center+radius)+mB);
        return Matrix::Max(derivleft, derivright);
      }
  };
#endif