#include <stdio.h>
#include <stdlib.h>

//  in quadratic_test.cpp
//bool SolveQuadratic(double a, double b, double c, double low, double high);
bool Contour1DTest();
void ProfileContour1D();

// in root1d_test.cpp
bool TestRoot1D();

// in root2d_test.cpp
bool TestRoot2D();

// in cntr2d_test.cpp
bool Contour2DTest();
void ProfileContour2D();

#include "int2dbs.h"

int main(int argc, char *argv[])
  {
#if 0
    Vertex_2D_Cubic_Base *v[3];
    for (int i=0; i<3; ++i)
      {
        DomainType2d pos;
        pos(0,0)=0;
        pos(0,1)=0;
        v[i]=new Vertex_2D_Cubic_Base(pos);
        v[i]->mFunctionValue=0;
        v[i]->mGradient(0,0)=0;
        v[i]->mGradient(0,1)=0;
      }
    v[1]->mPos(0,0)=1;
    v[2]->mPos(0,1)=1;
    v[1]->mGradient(0,0)=3;
    //v[1]->mFunctionValue=1;
    Root2D::TriangularCubic cubics[3];
    Interp2D::CloughTocher(v, cubics, 1e-12);
#endif

#if 0
    Vertex_2D_Cubic_Base *v[4];
    for (int i=0; i<4; ++i)
      {
        DomainType2d pos;
        pos(0,0)=0;
        pos(0,1)=0;
        v[i]=new Vertex_2D_Cubic_Base(pos);
        v[i]->mFunctionValue=0;
        v[i]->mGradient(0,0)=0;
        v[i]->mGradient(0,1)=0;
      }
    v[1]->mPos(0,0)=1;
    v[2]->mPos(0,0)=1;
    v[2]->mPos(0,1)=1;
    v[3]->mPos(0,1)=1;
    //v[2]->mFunctionValue=1;
    v[1]->mGradient(0,0)=2;
    //v[2]->mGradient(0,0)=2;
    //v[2]->mGradient(0,1)=1;
    Root2D::TriangularCubic cubics[4];
    Interp2D::SibsonSplitSquare(v, cubics, 1e-12);
#endif

#ifdef PROFILE_HOOKS
#ifdef PROFILE_2D
    ProfileContour2D();
#endif
#ifdef PROFILE_1D
    ProfileContour1D();
#endif
    return 0;
#else
    /*
    if (argc==6)
      SolveQuadratic(atof(argv[1]), atof(argv[2]), atof(argv[3]), atof(argv[4]), atof(argv[5]));
    else if (argc!=1)
      printf("Usage: contour [a b c low high]\n");
    else
      {
        SolveQuadratic(1, 0, -2, 0, 2);
        SolveQuadratic(1, 0, 0, -1./3, 2./3);
        SolveQuadratic(1, 0, -1, -1, 1);
      }
    */
    //bool good=TestRoot1D();
    bool good=Contour1DTest();
    good=TestRoot2D() && good;
    good=Contour2DTest() && good;
    if (! good)
      printf("Some test failed\n");
    return ! good;
#endif
  }