#ifndef __VERTEX_INFO_H
#define __VERTEX_INFO_H
#include "template.h"

template<class Position_T, class ExtraData_T>
class VertexInfo : public ExtraData_T
  {
public:
    typedef VertexInfo<Position_T, ExtraData_T> thistype;
    typedef typename Position_T PositionType;
    typedef ScalarType RangeType;
    
    PositionType mPos;
    RangeType  mFunctionValue;
    typedef enum { NotEvaluated=0, 
           ValueEvaluated=1, 
           InterpolationDataEvaluated=2,
           BothEvaluated=3
         } EvaluatedEnum;
    int mEvaluated;

    explicit VertexInfo(PositionType pos) 
        : mPos(pos),
          mEvaluated(NotEvaluated)
      {
      }
  };

template<class Position_T, class ExtraData_T>
class VertexInfoMaxD : public VertexInfo<Position_T, ExtraData_T>
  {
public:
    typedef VertexInfoMaxD<Position_T, ExtraData_T> thistype;
    
    ScalarType mSafeRadius;

    explicit VertexInfoMaxD(PositionType pos) 
        : VertexInfo<Position_T, ExtraData_T>(pos),
          mSafeRadius(0)
      {
      }
  };

#endif